import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.rmi.*;
//import java.net.MalformedURLException;
//import java.net.UnknownHostException;
import java.applet.Applet;
import Mud.PersonnageDistant;

class DisplayClient extends Canvas {
    AppletClient monApplet;
	Image icon;

    public void paint(Graphics g){
		   int largeurCase=getWidth()/monApplet.largeur;
		   int hauteurCase=getHeight()/monApplet.hauteur;
		   drawGrille(g,largeurCase,hauteurCase);
		   drawPersonnage(g,largeurCase,hauteurCase);
    }

    void drawGrille(Graphics g, int l, int h){
		 g.setColor(Color.darkGray);
		 for(int i=0;i<monApplet.largeur;i++){
			g.drawLine(i*l,0,i*l,getHeight());
		 }
         g.drawLine(getWidth()-1,0,getWidth()-1,getHeight());
		 for(int j=0;j<monApplet.hauteur;j++){
			g.drawLine(0,j*h,getWidth(),j*h);
		 }
         g.drawLine(0,getHeight()-1,getWidth(),getHeight()-1);
	}

	void drawPersonnage(Graphics g, int l, int h){
        PersonnageDistant p = monApplet.getPersonnage();
        if (p != null){
          try{
            g.setColor(AppletClient.getColor(p.getCouleur()));
            int colonne=p.getColonne();
            int rangee=p.getRangee();
            
       
            if (icon == null){
            	icon = Toolkit.getDefaultToolkit().getImage("images/robot1.gif");
            }

//    		int h = icon.getHeight(this);
//    		int w = icon.getWidth(this);
            g.drawRect(colonne * l + 1,rangee * h + 1,l - 2,h - 2);
            g.drawImage(icon,colonne * l + 1,rangee * h + 1,l - 2,h - 2,this);
          } catch(RemoteException e){
            System.out.println("RemoteException: " + e.getMessage());
          }
        }
	}

    DisplayClient(AppletClient a){
        monApplet=a;
    }
}

public class AppletClient extends Frame implements ActionListener {

    int largeur=10;
    int hauteur=10;

    public int getLargeur(){return largeur;}
    public int getHauteur(){return hauteur;}

    DisplayClient gui;
    String serveurName="localhost";
    public String getServeurName(){return serveurName;}
    public void setServeurName(String s){serveurName = s;}

    PersonnageDistant perso;
    public PersonnageDistant getPersonnage(){return perso;}

 //constructeur
 public AppletClient(){
 	addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
            System.exit(0);
        }
    });
    setLayout(new BorderLayout());

     System.setProperty("java.security.policy","rmi.policy");
    if (System.getSecurityManager() == null) {
        System.setSecurityManager(new RMISecurityManager());
    }
    
    gui = new DisplayClient(this);
    add(gui);

    Button ab4=new Button("gauche");
    Button ab1=new Button("haut");
    Button ab2=new Button("bas");
    Button ab3=new Button("droite");
    Button ab5=new Button("select");
    Panel p2= new Panel();
        //comboPerso=new ComboBox();
    p2.add(ab4);
    p2.add(ab1);
    p2.add(ab2);
    p2.add(ab3);
    p2.add(ab5);

    add(p2,BorderLayout.SOUTH);
    ab1.addActionListener(this);
    ab2.addActionListener(this);
    ab3.addActionListener(this);
    ab4.addActionListener(this);
    ab5.addActionListener(this);

 }


 void selectPersonnage(String persoId){
    try {
        System.out.println("Recupere le personnage : " + persoId);
        perso = (PersonnageDistant) Naming.lookup(persoId);
        System.out.println("Personnage distant recupere "+perso);
        gui.repaint();
    }
    catch(Exception e){
            System.out.println("Exception: " + e.getMessage());
    }
 }


public void actionPerformed(ActionEvent e) {
    String s = e.getActionCommand();
    try { System.out.println("commande: " + s + " sur " + perso);
        if (s.equals("haut")){
             if (perso != null)
                perso.haut();
        }else if (s.equals("bas")){
             if (perso != null)
                perso.bas();
        } else if (s.equals("droite")){
             if (perso != null)
                perso.droite();
        } else if (s.equals("gauche")){
             if (perso != null)
                perso.gauche();
        } else if (s.equals("select")){
            System.out.println("selection du personnage...");
            new SelectDialog(this);
        }
        gui.repaint();
    } catch(RemoteException ex){
            System.out.println("RemoteException: " + ex.getMessage());
    }
 }


public static void main(String args[]) {
   try {
        Frame f = new AppletClient();
        f.setSize(500, 400);
        f.show();
      }
    catch (Exception e) {
      System.out.println("Exception "+ e.getMessage());
    }
 } 

  static public Color getColor(int c) {
            switch(c) {
                case 0: return(Color.blue);
                case 1: return(Color.cyan);
                case 2: return(Color.red);
                case 3: return(Color.green);
                case 4: return(Color.magenta);
                case 5: return(Color.orange);
                case 6: return(Color.pink);
                case 7: return(Color.yellow);
                default : return(Color.blue);
            }
  	    }

}