import java.awt.*;
import java.awt.event.*;
import java.rmi.*;

/**
 * Title:        Mud
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author J. Ferber
 * @version 1.0
 */

public class SelectDialog extends Frame {
    Panel panel1 = new Panel();
    Label label1 = new Label();
    Choice selector = new Choice();
    Button okButton = new Button();
    Button cancelButton = new Button();

    String[] persoList;
    String persoId;

    AppletClient applet;
    TextField serveurField = new TextField();
    Label label2 = new Label();

    public SelectDialog(AppletClient  app) {
        super("Selection");
        applet=app;
        try {
            add(panel1);
            jbInit();
            connection();
            setSize(500,300);
            pack();
            show();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
    	panel1.setLayout(new BorderLayout());
        label1.setAlignment(1);
        label1.setFont(new java.awt.Font("Dialog", 0, 18));
        label1.setText("Selectionnez le personnage");
        //label1.setBounds(new Rectangle(45, 25, 321, 34));
        okButton.setLabel("OK");
        //okButton.setBounds(new Rectangle(87, 223, 73, 28));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                okButton_actionPerformed(e);
            }
        });
        cancelButton.setLabel("Annuler"); 
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancel_actionPerformed(e);
            }
        });
        //cancelButton.setBounds(new Rectangle(198, 220, 77, 30));
        selector.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                selector_itemStateChanged(e);
            }
        });
        //selector.setBounds(new Rectangle(52, 72, 264, 31));
        //serveurField.setBounds(new Rectangle(165, 146, 148, 24));
        serveurField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                serveurField_actionPerformed(e);
            }
        });
        serveurField.setText(applet.getServeurName());
        label2.setFont(new java.awt.Font("Dialog", 1, 12));
        label2.setText("Nom du serveur : ");
       // label2.setBounds(new Rectangle(54, 145, 105, 26));
        Panel pbutton = new Panel();
        pbutton.add(okButton);
        pbutton.add(cancelButton);
        panel1.add(pbutton,BorderLayout.SOUTH);
        panel1.add(label1, BorderLayout.NORTH);
        Panel pCentral = new Panel(new GridLayout(2,1));
        Panel pSelect = new Panel(new GridLayout(1,2));
        pCentral.add(selector);
        pCentral.add(pSelect);
        pSelect.add(label2);
        pSelect.add(serveurField);
        panel1.add(pCentral, BorderLayout.CENTER);
    }

    void connection(){
    // recherche de nom dans les registres
           try {
             persoList=Naming.list("//"+applet.getServeurName()+"/");
             for(int i=0;i<persoList.length;i++)
                selector.addItem(persoList[i]);
           }
           catch (Exception e) {
             System.out.println("Exception "+ e.getMessage());
           }
    }

    protected void processWindowEvent(WindowEvent e) {
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            cancel();
        }
        super.processWindowEvent(e);
    }

    void cancel() {
        dispose();
    }

    void okButton_actionPerformed(ActionEvent e){
        if (persoId != null)
            applet.selectPersonnage(persoId);
        applet.setServeurName(serveurField.getText());
        dispose();
    }
    
    void cancel_actionPerformed(ActionEvent e){
        dispose();
    }

    void selector_itemStateChanged(ItemEvent e) {
        Choice src=(Choice) e.getSource();
        persoId = src.getSelectedItem();
    }

    void serveurField_actionPerformed(ActionEvent e) {
        TextField t=(TextField) e.getSource();
        applet.setServeurName(t.getText());
    }
}
